#include "incl.h"

help ()
{
   printf ("           ***** PROGRAM  %s %s *****\nUsage:\n%s", 
           PROG_NAME, VERSION, PROG_NAME);
   printf ("\t[-P -G -O -D -T -H] [-d] [-f] [-h#] [-w#] [-b#,#,#,#]\n");
   printf ("\t[-s#,#] [-oOutputfile] inputfile\n");
   printf ("\n");
   printf ("\t-D            DrawPerfect input.\n");
   printf ("\t-P            PSpice input.\n");
   printf ("\t-G            Gem input.\n");
   printf ("\t-O            Orcad input.\n");
   printf ("\t-T            Gnuplot input.\n");
   printf ("\t-H            PrintGL input.\n");
   printf ("\n");
   printf ("\t-b#,#,#,#     boundingbox in millimeters.\n");
   printf ("\t-w#           picture width in millimeters <= %d\n", MAX_WIDTH);
   printf ("\t-h#           picture height in millimeters <= %d\n",
           MAX_HEIGHT);
   printf ("\t-s#,#         space in millimeters above and below picture.\n");
   printf ("\t-d            PSpice headerline with Date, Time and Temperature.\n");
   printf ("\t-f            No Orcad boundingbox frame around the picture.\n");
   printf ("\t-oOutputfile  outputfile name.\n");
   printf ("\n");
   return (EXIT_SUCCESS);
}
